import tkinter as tk
import random

count = 0
count2 = 0
temp = 0
root = tk.Tk()


# background_image = tk.PhotoImage(file='font.png')
# background_label = tk.Label(root, image=background_image)
# background_label.place(relwidth=1, relheight=1)


class Node:
    def __init__(self, value=None):
        self.value = value
        self.next = None


class List:
    def __init__(self):
        self.head = Node()

    def add(self, value):
        new_Node = Node(value)
        cur = self.head
        while cur.next is not None:
            cur = cur.next
        cur.next = new_Node

        elem = []
        cur_node = self.head
        while cur_node.next is not None:
            cur_node = cur_node.next
            elem.append(cur_node.value)

    def summary(self):
        cur = self.head
        while cur.next is not None:
            temp23 = cur.value
            cur = cur.next
        if cur.next is None:
            temp32 = cur.value
        u = int(temp23) + int(temp32)
        return u


class Queue:
    def __init__(self):
        self.item = []
        for i in range(1, 15):
            x = random.randint(0, 30)
            self.push(x)
            text_queue.configure(state="normal")
            text_queue.insert(0.0, x)
            text_queue.insert(0.0, '\n')
            text_queue.configure(state="disabled")

    def push(self, item):
        self.item.append(item)

    def pop(self):
        return self.item.pop(0)

    def check(self):
        check = False
        x = int(S_queue.get())
        for i in range(0, len(self.item)):
            if self.item[i] == x:
                check = True
        return check


class Stack:
    def __init__(self):
        self.items = []

    def isEmpty(self):
        return self.items == []

    def push(self, item):
        self.items.append(item)

    def pop(self):
        return self.items.pop()


# region Functions
def add_num(entry):
    if len(entry) != 0:
        list_1.add(entry)
        text_list.configure(state="normal")
        text_list.insert(0.0, entry)
        text_list.insert(0.0, '\n')
        text_list.configure(state="disabled")


def Sum():
    y = list_1.summary()
    label_list.configure(text="Сумма: " + str(y))


def Search(entry):
    if len(entry) != 0:
        if queue_1.check():
            label_queue.configure(text="Число найдено")
        else:
            label_queue.configure(text="Число не найдено")


def FillStack(entry):
    global count2
    if len(entry) != 0:
        stack_1.push(entry)
        text_stack.configure(state="normal")
        text_stack.insert(0.0, entry)
        text_stack.insert(0.0, '\n')
        text_stack.configure(state="disabled")
        count2 += 1


def Replace():
    global temp
    if not stack_1.isEmpty():
        text_stack.config(state="normal")
        text_stack.delete(1.0, tk.END)
        while not stack_1.isEmpty():
            u = stack_1.pop()
            stack_2.push(u)
        temp = stack_2.pop()
        while not stack_2.isEmpty():
            u = stack_2.pop()
            stack_1.push(u)
            text_stack.insert(0.0, u)
            text_stack.insert(0.0, '\n')
        stack_1.push(temp)
        text_stack.insert(0.0, temp)
        text_stack.insert(0.0, '\n')
        text_stack.config(state="disabled")


# endregion

# region UI list
text_list = tk.Text(root, font=12, width=25, height=20)
text_list.configure(state="disabled")
text_list.place(relx=0.05, rely=0.14)

label_name = tk.Label(root, font=12, text="Output", fg='black', bg='white')
label_name.place(relx=0.09, rely=0.141, relwidth=0.15, relheight=0.05)

label_list = tk.Label(root, font=12, fg='black', bg='white')
label_list.place(relx=0.05, rely=0.91, relwidth=0.15, relheight=0.05)

entry_list = tk.Entry(root, font=12)
entry_list.place(relx=0.05, rely=0.05, relwidth=0.15, relheight=0.05)

button_add = tk.Button(root, text="Add", command=lambda: add_num(entry_list.get()))
button_add.place(relx=0.205, rely=0.05)

button_check = tk.Button(root, text="Sum", command=lambda: Sum())
button_check.place(relx=0.205, rely=0.91)
# endregion
# region UI queue

text_queue = tk.Text(root, font=12, width=25, height=20)
text_queue.configure(state="disabled")
text_queue.place(relx=0.383, rely=0.14)

label_name_q = tk.Label(root, font=12, text="Output", fg='black', bg='white')
label_name_q.place(relx=0.426, rely=0.141, relwidth=0.15, relheight=0.05)

S_queue = tk.Entry(root, font=12)
S_queue.place(relx=0.384, rely=0.05, relwidth=0.15, relheight=0.05)

label_queue = tk.Label(root, font=12, fg='black', bg='white')
label_queue.place(relx=0.384, rely=0.91, relwidth=0.2, relheight=0.05)

button_Search = tk.Button(root, text="Search", command=lambda: Search(S_queue.get()))
button_Search.place(relx=0.538, rely=0.05)
# endregion
# region UI stack
entry_stack = tk.Entry(root, font=12)
entry_stack.place(relx=0.710, rely=0.05, relwidth=0.15, relheight=0.05)

button_stack = tk.Button(root, text="Add", command=lambda: FillStack(entry_stack.get()))
button_stack.place(relx=0.865, rely=0.05)

text_stack = tk.Text(root, font=12, width=25, height=20)
text_stack.configure(state="disabled")
text_stack.place(relx=0.710, rely=0.14)

label_name_s = tk.Label(root, font=12, text="Output", fg='black', bg='white')
label_name_s.place(relx=0.753, rely=0.141, relwidth=0.15, relheight=0.05)

button_Replace = tk.Button(root, text="Replace", command=lambda: Replace())
button_Replace.place(relx=0.710, rely=0.91, relwidth=0.23, relheight=0.05)
# endregion
queue_1 = Queue()
list_1 = List()
stack_1 = Stack()
stack_2 = Stack()
if __name__ == "__main__":
    root.title("Lab_1")
    root.geometry("1000x500")
    root.resizable(False, False)
    root.mainloop()
